com.holonplatform.core

## Interface TypedExpression<T>

- Type Parameters:
    `T` - Expression type
  All Superinterfaces:
    Expression
  All Known Subinterfaces:
    Aliasable.AliasablePath<T,C>, BeanDataTarget<T>, BeanProjection<T>, BeanProperty<T>, BeanProperty.Builder<T>, BooleanBeanProperty, BooleanProperty, BooleanProperty.BooleanPropertyBuilder, CloneableProperty<T,P,B>, CloneableProperty.CloneablePathProperty<T,P>, CollectionConstantExpression<T>, CollectionExpression<E,C>, CollectionPathProperty<E,C>, CollectionProperty<E,C>, CollectionProperty.ListProperty<T>, CollectionProperty.SetProperty<T>, ConstantConverterExpression<T,E>, ConstantExpression<T>, ConverterExpression<T>, CountAllProjection, DataTarget<T>, Join<T>, ListPathProperty<T>, ListPathProperty.ListPathPropertyBuilder<T>, ListVirtualProperty<T>, ListVirtualProperty.ListVirtualPropertyBuilder<T>, NullExpression<T>, NumericBeanProperty<N>, NumericProperty<N>, NumericProperty.NumericPropertyBuilder<N>, NumericQueryExpression<N>, Path<T>, Path.FinalPath<T>, Path.FinalPath.FinalPathBuilder<T>, Path.PathBuilder<T>, PathExpression<T>, PathProperty<T>, PathProperty.PathPropertyBuilder<T>, Property<T>, PropertyBoxProperty, PropertyBoxProperty.PropertyBoxPropertyBuilder, PropertySetProjection, QueryExpression<T>, QueryFunction<T,A>, QueryFunction.Avg, QueryFunction.Count, QueryFunction.Max<T>, QueryFunction.Min<T>, QueryFunction.NoArgQueryFunction<T>, QueryFunction.PropertyQueryFunction<T,A>, QueryFunction.Sum<T>, QueryOperation<C,R>, QueryProjection<T>, RelationalTarget<T>, SelectAllProjection, SetPathProperty<T>, SetPathProperty.SetPathPropertyBuilder<T>, SetVirtualProperty<T>, SetVirtualProperty.SetVirtualPropertyBuilder<T>, StringBeanProperty, StringFunction, StringFunction.Lower, StringFunction.Upper, StringProperty, StringProperty.StringPropertyBuilder, StringQueryExpression, SubQuery<T>, TemporalBeanProperty<T>, TemporalFunction<T>, TemporalFunction.CurrentDate, TemporalFunction.CurrentLocalDate, TemporalFunction.CurrentLocalDateTime, TemporalFunction.CurrentTimestamp, TemporalFunction.Day, TemporalFunction.Hour, TemporalFunction.Month, TemporalFunction.Year, TemporalProperty<T>, TemporalProperty.TemporalPropertyBuilder<T>, TemporalQueryExpression<T>, VirtualProperty<T>, VirtualProperty.Builder<T,P,B>, VirtualProperty.VirtualPropertyBuilder<T>
  All Known Implementing Classes:
    AbstractConverterExpression, DefaultCollectionConstantExpression, DefaultConstantConverterExpression, DefaultFinalPath, DefaultNullExpression, DefaultPath

      public interface TypedExpression<T>
      extends Expression

  An `Expression` with a declared type.
  Since:
    5.1.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>, Expression.InvalidExpressionException`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default Optional<TemporalType>` | `getTemporalType()` If the expression type represents a temporal type, get the actual `TemporalType` of the type.
    `Class<? extends T>` | `getType()` Get the expression type.
    `default Optional<CollectionExpression<?,?>>` | `isCollectionExpression()` Checks if this expression is a `CollectionExpression`.
    `default Optional<ConverterExpression<T>>` | `isConverterExpression()` Checks if this expression is a `ConverterExpression`.

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

- - ### Method Detail

    - #### getType

          Class<? extends T> getType()

      Get the expression type.
      Returns:
        Expression type

    - #### getTemporalType

          default Optional<TemporalType> getTemporalType()

      If the expression type represents a temporal type, get the actual `TemporalType` of the type.
      Returns:
        Optional temporal type

    - #### isConverterExpression

          default Optional<ConverterExpression<T>> isConverterExpression()

      Checks if this expression is a `ConverterExpression`.
      Returns:
        If this expression is a `ConverterExpression` returns the expression itself as a `ConverterExpression`, or an empty Optional otherwise

    - #### isCollectionExpression

          default Optional<CollectionExpression<?,?>> isCollectionExpression()

      Checks if this expression is a `CollectionExpression`.
      Returns:
        If this expression is a `CollectionExpression` returns the expression itself as a `CollectionExpression`, or an empty Optional otherwise

Copyright © 2019 The Holon Platform. All rights reserved.